        DEVICE ZXSPECTRUM128
		org	#6000
begin
 include "TSPor.inc"

run_part:
 ld bc,TSConfig
 xor a
 out (c),a

 ld a,6,bc,SysConfig:out (c),a

; VIDEO
VID_256X192     equ $00
VID_320X200     equ $40
VID_320X240     equ $80
VID_360X288     equ $C0
VID_ZX          equ $00
VID_16C         equ $01
VID_256C        equ $02
VID_TEXT        equ $03
VID_NOGFX       equ $20
; TSU
TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

;---zero video
;; ld a,11;10 xor 1,font at page 10
;;inf_zp:
;; call clear_page_dma

 LD  BC,VPage
 LD  A,11
 OUT (C),A

 ld bc,Page3
 OUT (C),A

 LD  BC,VConfig
 LD  A,VID_TEXT|VID_360X288
 OUT (C),A

;palette
 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld hl,inf_pal_b
 ld de,0
 ld bc,inf_pal_e-inf_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a

 ld bc,PalSel
 ld a,0
 out (c),a

 ld a,0,bc,Border:out (c),a

; ld bc,Page3
; ld a,12
; OUT (C),A
 call dma_c
 
wk:ei:halt
 ld a,$EF:in a,($FE):and $10:jp z,down;7
 ld a,$EF:in a,($FE):and $08:jp z,up;6
 jp wk
up:
 ld a,(line):or a:jp z,wk
 dec a:ld (line),a
 ld hl,(ans_adr+1)
 dec h
 ld a,h:cp $bF:jr nz,no_up
 ld h,$FF
 ld a,(ans_pg+1):dec a:ld (ans_pg+1),a
no_up:
 ld (ans_adr+1),hl:call dma_c
 jp wk


down:
 ld a,(line):cp 171-36:jp z,wk
 inc a:ld (line),a
 ld hl,(ans_adr+1)
 inc h
 jp nz,no_down
  ld h,$C0
  ld a,(ans_pg+1):inc a:ld (ans_pg+1),a
no_down:
 ld (ans_adr+1),hl
 call dma_c
 jp wk
line:db 0
;-----------------------------------------------------------------------------
dma_c:
		ld	bc,DMASAddrX	;
ans_pg:		ld	a,12;x		; x -    
		out	(c),a		;
ans_adr:		ld	hl,$C000;;+5*256;xxxx		;    
		ld	bc,DMASAddrH	;
		out	(c),h		;
		ld	bc,DMASAddrL	;
		out	(c),l		;
	
		ld	bc,DMADAddrX	;
		ld	a,11;;#20;;y		; y -    
		out	(c),a		;

		ld	hl,$C000;;yyyy		;     

		ld	bc,DMADAddrH	;
		out	(c),h		;
		ld	bc,DMADAddrL	;
		out	(c),l		;
	
		ld	bc,DMALen	;
		ld	a,128-1		;     (0- 2 ,1- 4 ,2- 6 6  .) .     255 - 512 
		out	(c),a
	
		ld	bc,DMANum	;  ,   0, .       ,  0
		ld	a,0+35
		out	(c),a

		ld	bc,DMACtrl	;
		ld	a,%00000001	;   RAM-RAM (0)0000(001),  
		out	(c),a		;

c1rl:	ld	bc,DMAStatus	; 
		in	a,(c)
		or	a
		jr	nz,c1rl

;	..        ,               
;	      , 0     .     0001h,     0000h
	ret
;----------------------
inf_pal_b:
 incbin "anspal.bin"
inf_pal_e:


end
	display /d,end-begin
	savebin "tm.bin",begin,end-begin


	LUA ALLPASS
	local fp = assert(io.open("tm.ini", "wb"))

	fp:write(";Description of a build - up to 32 chars\r\n")
	fp:write("Desc = Cat's Craddle\r\n")

	fp:write(";Start address\r\n")

	local ss=tostring( sj.get_label("run_part") )
	ss=string.gsub(ss , "%s", "")
	fp:write("Start =")
	fp:write(string.format("#%x",ss) )
	fp:write("\r\n")

	fp:write(";SP adddress\r\n")
	fp:write("Stack = 24575\r\n")

	fp:write(";Resident address (16 bytes long)\r\n")
	fp:write("Resident = #5B00\r\n")
	
	fp:write(";Page at #C000 when started\r\n")
	fp:write("Page3 = 0\r\n")

	fp:write("; CPU clock: 0 - 3,5MHz / 1 - 7MHz / 2 - 14MHz / 3 - 14+MHz\r\n")
	fp:write("Clock = 1\r\n")

	fp:write("; INT: 0 - DI / 1 - EI\r\n")
	fp:write("INT = 0\r\n")

	fp:write(";Pager address (0 - not used)\r\n")
	fp:write("Pager = 0\r\n")

	fp:write("; Blocks description: address (512 multiple, #C000-#FE00), page number, filename\r\n")
	fp:write("Block = #E000,5,tm.bin\r\n")

	fp:write("Block = #C000,10,Rus.fnt\r\n")
	
	fp:write("Block = #C000,12,girl.001\r\n")
	fp:write("Block = #C000,13,girl.002\r\n")
	fp:write("Block = #C000,14,girl.003\r\n")

	assert(fp:close())
	ENDLUA

